<?php
session_start();
//Definim la codificacio de la capçelera
header('Content-Type: text/html; charset=utf-8');

// incluim les funcions per validar el formulari
include 'php/funcionsValidar.php';


// Guardem els valors dels camps en variables si s'han enviat pel formulari, sino es guardarà la variable amb null
$nom = isset($_POST['nom']) ? $_POST['nom'] : null;
$cognom = isset($_POST['cognom']) ? $_POST['cognom'] : null;
$email = isset($_POST['mail']) ? $_POST['mail'] : null;
$telefon = isset($_POST['telefon']) ? $_POST['telefon'] : null;
$nomNen = isset($_POST['nomNen']) ? $_POST['nomNen'] : null;
$edat = isset($_POST['edat']) ? $_POST['edat'] : null;
$numNens = isset($_POST['numNens']) ? $_POST['numNens'] : null;
$dataReserva = isset($_POST['dataReserva']) ? $_POST['dataReserva'] : null;
$torn = isset($_POST['torn']) ? $_POST['torn'] : null;
$observacions = isset($_POST['observacions']) ? $_POST['observacions'] : null;


// Guardem els valors del formulari per no perdre les dades si hi ha un error
if (isset($nom)){
		$_SESSION['nomSession']=$nom;
}
if (isset($cognom)){
		$_SESSION['cognomSession']=$cognom;
}
if (isset($email)){
		$_SESSION['emailSession']=$email;
}
if (isset($telefon)){
		$_SESSION['telefonSession']=$telefon;
}
if (isset($nomNen)){
		$_SESSION['nomNenSession']=$nomNen;
}
if (isset($edat)){
		$_SESSION['edatSession']=$edat;
}
if (isset($numNens)){
		$_SESSION['numNensSession']=$numNens;
}
if (isset($dataReserva)){
		$_SESSION['dataReservaSession']=$dataReserva;
}
if (isset($torn)){
		$_SESSION['tornSession']=$torn;
}
if (isset($observacions)){
		$_SESSION['observacionsSession']=$observacions;
}


// Guardem la data actual del sistema
$dataActual = date("Y/m/d");

// Convertim les dades de les dates en format de php
   $dataConvertida = strtotime($dataReserva);
   $dataactualConv = strtotime($dataActual);
   
// Calculem la diferencia de dias entre la data actual i la data de la reserva
$difDias= ($dataConvertida - $dataactualConv)/86400;



// Convertim les dades numeriques a text per treure els espais en blanc
$telefonText = (String)$telefon;
$edatText = (String)$edat;
$numNensText = (String)$numNens;

// Treiem els espais en blanc
$telefonText =  limpia_espacios($telefonText);
$edatText =  limpia_espacios($edatText);
$numNensText =  limpia_espacios($numNensText);

// Tornem les dades a numeriques
$telefon = (int) $telefonText;
$edat = (int) $edatText;
$numNens = (int) $numNensText;


// Creem un array d'errors per validar quins errors tenim en l'aplicació
$errores = array();

// Validar les diferents variables obtingudes del formulari

	// Validem si s'ha omplert la dada del nom
   if (!validaRequerido($nom)) {
      $errores[] = 'Falta omplir les dades de nom.';
   }
   // Validem si s'ha omplert la dada del cognom
   if (!validaRequerido($cognom)) {
      $errores[] = 'Falta omplir les dades de cognom.';
   }
   //Validem si s'ha omplert la dada del email
   if (!validaRequerido($email)) {
      $errores[] = 'Falta omplir les dades del e-mail.';
   } 
   // Validem que el email es correcte
   else if(!validaEmail($email)) {
      $errores[] = 'El format del e-mail es incorrecte.';
   }

	// Validem si s'ha omplert la dada del telefon
   if (!validaRequerido($telefon)) {
      $errores[] = 'Falta omplir la dada del telefon.';
   }
   else{
   //Valida el telefon entre 11111111 i 999999999
   $opcions_telefon = array(
      'options' => array(
         //Definimos el rango de edad entre 11111111 a 999999999.
         'min_range' => 11111111,
         'max_range' => 999999999
      )
   );
   if (!validarEntero($telefon, $opcions_telefon)) {
      $errores[] = 'El número telefonic ha de ser entre 11111111 i 999999999.';
   }
   }   
	// Validem si s'ha omplert la dada del nom del nen
   if (!validaRequerido($nomNen)) {
      $errores[] = 'Falta omplir les dades de nom del nen.';
   }

	// Validem si s'ha omplert la dada d'edat
   if (!validaRequerido($edat)) {
      $errores[] = 'Falta omplir la dada de la edat.';
   }
   
   else{
   //Valida l'edat entre 3 i 12 anys
   $opcions_edat = array(
      'options' => array(
         //Definimos el rango de edad entre 1 a 12.
         'min_range' => 1,
         'max_range' => 12
      )
   );
   if (!validarEntero($edat, $opcions_edat)) {
      $errores[] = 'La edat del nen ha de ser entre 1 i 15 anys.';
   }
   }
   
 	// Validem si s'ha omplert la dada del numero de nens
   if (!validaRequerido($numNens)) {
      $errores[] = 'Falta omplir la dada del numero de nens.';
   }
   
   else{
   //Valida entre 1 i 60 nens
   $opcions_numNens = array(
      'options' => array(
         //Definimos el rango de edad entre 1 a 60.
         'min_range' => 1,
         'max_range' => 60
      )
   );
   // Validem si el numero de nens esta entre 1 i 60
   if (!validarEntero($numNens, $opcions_numNens)) {
      $errores[] = 'El numero de nens ha ser entre 1 i 60.';
		}
   } 
  
   // Validem si s'ha omplert la dada del data de reserva
   if (!validaRequerido($dataReserva)) {
      $errores[] = 'Falta omplir les dades de la data.';
   } 
   // Validem que la data es correcte
    else if (!validateDateEn($dataReserva)) {
      $errores[] = 'El format de la data ha de ser aaaa/mm/dd (any/mes/dia)';
   }
   
   // Comprobem que la reserva es minim 3 dias abas de la data actual
   else if ($difDias <=2){
    $errores[] = 'El dia de la reserva mínim 3 dies despres del actual';
   } 

   if ($torn == 0){
   $errores[] = 'Has de seleccionar un torn';
   }


  
   // Si no hi han errors conectem a la base de dades i fent els calculs per introduir en la base de dades
   if(!$errores){


   // Treiem el dia de la setmana per calcular la tarifa de preu
include 'php/diaSetmana.php';  
   
// Conectem a la base de dades   
include 'php/dadesConexio.inc.php';

// Definim una variable per validar si la reserva esta disponible
$reservaDisponible = true;

   // Calculem si la reserva esta disponible
include 'php/reservaDisponible.php';

if ($reservaDisponible){

// Escapem els diferents elements i eliminem les posibles etiquetes html per evitar atacs d'injecció SQL
$nom =  strip_tags((htmlspecialchars($nom, ENT_QUOTES)));
$cognom =  strip_tags((htmlspecialchars($cognom, ENT_QUOTES)));
$email =  strip_tags((htmlspecialchars($email, ENT_QUOTES)));
$telefon =  strip_tags((htmlspecialchars($telefon, ENT_QUOTES)));
$nomNen =  strip_tags((htmlspecialchars($nomNen, ENT_QUOTES)));
$edat =  strip_tags((htmlspecialchars($edat, ENT_QUOTES)));
$numNens =  strip_tags((htmlspecialchars($numNens, ENT_QUOTES)));
$dataReserva =  strip_tags((htmlspecialchars($dataReserva, ENT_QUOTES)));
$torn =  strip_tags((htmlspecialchars($torn, ENT_QUOTES)));
$observacions =  strip_tags((htmlspecialchars($observacions, ENT_QUOTES)));

// Fem una consulta per calcular el identificador del preu de la reserva
$query = "SELECT id  FROM tarifes WHERE torn='$torn' AND dia='$codiDia'";
$resultat = mysql_query($query) or die('Consulta fallida: ' . mysql_error());

$arrayPreu=mysql_fetch_array($resultat);
$preu = $arrayPreu[0];

// Insertem les dades de la reserva en la base de dades
$sql = "INSERT INTO reserva (nom, cognoms, email, telefon, nom_nen, edat, num_nens, diaActual, dia, tarifa, torn, prepago, observacions) " .
  "VALUES ('$nom', '$cognom', '$email', '$telefon', '$nomNen', '$edat', '$numNens', '$dataActual', '$dataReserva', '$preu', '$torn', false, '$observacions' )";
  $resultat = mysql_query($sql) or die('Dades no introduides: ' . mysql_error());

	$_SESSION['reservaOK']="reserva ok";
	// Taquem la conexió
	mysql_close($link);
	header("Location:formulari.php");

} else {

	$_SESSION['reservaOcupada']="reserva ocupada";
	// Taquem la conexió
	mysql_close($link);
	header("Location:formulari.php");
}

   }
   
   else{
   foreach ($errores as &$valor) {
	$_SESSION['errorFormulari']=$valor;
	header("Location:formulari.php");
	}
   
   }

?>